/**
 * This class file was automatically generated by the AXDR compiler that is part of jDLMS (http://www.openmuc.org)
 */

package org.openmuc.jdlms.internal.asn1.cosem;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jdlms.internal.asn1.axdr.AxdrType;
import org.openmuc.jdlms.internal.asn1.axdr.types.AxdrEnum;
import org.openmuc.jdlms.internal.asn1.axdr.types.AxdrOctetString;

public class COSEMpdu implements AxdrType {

	public byte[] code = null;

	public static enum Choices {
		_ERR_NONE_SELECTED(-1),
		INITIATEREQUEST(1),
		READREQUEST(5),
		WRITEREQUEST(6),
		INITIATERESPONSE(8),
		READRESPONSE(12),
		WRITERESPONSE(13),
		CONFIRMEDSERVICEERROR(14),
		UNCONFIRMEDWRITEREQUEST(22),
		INFORMATIONREPORTREQUEST(24),
		GLO_INITIATEREQUEST(33),
		GLO_READREQUEST(37),
		GLO_WRITEREQUEST(38),
		GLO_INITIATERESPONSE(40),
		GLO_READRESPONSE(44),
		GLO_WRITERESPONSE(45),
		GET_REQUEST(192),
		SET_REQUEST(193),
		EVENT_NOTIFICATION_REQUEST(194),
		ACTION_REQUEST(195),
		GET_RESPONSE(196),
		SET_RESPONSE(197),
		ACTION_RESPONSE(199),
		GLO_GET_REQUEST(200),
		GLO_SET_REQUEST(201),
		GLO_EVENT_NOTIFICATION_REQUEST(202),
		GLO_ACTION_REQUEST(203),
		GLO_GET_RESPONSE(204),
		GLO_SET_RESPONSE(205),
		GLO_ACTION_RESPONSE(207),
		DED_GET_REQUEST(208),
		DED_SET_REQUEST(209),
		DED_EVENT_NOTIFICATION_REQUEST(210),
		DED_ACTIONREQUEST(211),
		DED_GET_RESPONSE(212),
		DED_SET_RESPONSE(213),
		DED_ACTION_RESPONSE(215),
		EXCEPTION_RESPONSE(216),;

		private int value;

		private Choices(int value) {
			this.value = value;
		}

		public int getValue() {
			return this.value;
		}

		public static Choices valueOf(long tagValue) {
			Choices[] values = Choices.values();

			for (Choices c : values) {
				if (c.value == tagValue) {
					return c;
				}
			}
			return _ERR_NONE_SELECTED;
		}
	}

	private Choices choice;

	public InitiateRequest initiateRequest = null;

	public ReadRequest readRequest = null;

	public WriteRequest writeRequest = null;

	public InitiateResponse initiateResponse = null;

	public ReadResponse readResponse = null;

	public WriteResponse writeResponse = null;

	public ConfirmedServiceError confirmedServiceError = null;

	public UnconfirmedWriteRequest unconfirmedWriteRequest = null;

	public InformationReportRequest informationReportRequest = null;

	public AxdrOctetString glo_initiateRequest = null;

	public AxdrOctetString glo_readRequest = null;

	public AxdrOctetString glo_writeRequest = null;

	public AxdrOctetString glo_initiateResponse = null;

	public AxdrOctetString glo_readResponse = null;

	public AxdrOctetString glo_writeResponse = null;

	public GET_Request get_request = null;

	public SET_Request set_request = null;

	public EVENT_NOTIFICATION_Request event_notification_request = null;

	public ACTION_Request action_request = null;

	public GET_Response get_response = null;

	public SET_Response set_response = null;

	public ACTION_Response action_response = null;

	public AxdrOctetString glo_get_request = null;

	public AxdrOctetString glo_set_request = null;

	public AxdrOctetString glo_event_notification_request = null;

	public AxdrOctetString glo_action_request = null;

	public AxdrOctetString glo_get_response = null;

	public AxdrOctetString glo_set_response = null;

	public AxdrOctetString glo_action_response = null;

	public AxdrOctetString ded_get_request = null;

	public AxdrOctetString ded_set_request = null;

	public AxdrOctetString ded_event_notification_request = null;

	public AxdrOctetString ded_actionRequest = null;

	public AxdrOctetString ded_get_response = null;

	public AxdrOctetString ded_set_response = null;

	public AxdrOctetString ded_action_response = null;

	public EXCEPTION_Response exception_response = null;

	public COSEMpdu() {
	}

	public COSEMpdu(byte[] code) {
		this.code = code;
	}

	@Override
	public int encode(BerByteArrayOutputStream axdrOStream) throws IOException {
		if (code != null) {
			for (int i = code.length - 1; i >= 0; i--) {
				axdrOStream.write(code[i]);
			}
			return code.length;

		}
		if (choice == Choices._ERR_NONE_SELECTED) {
			throw new IOException("Error encoding AxdrChoice: No item in choice was selected.");
		}

		int codeLength = 0;

		if (choice == Choices.EXCEPTION_RESPONSE) {
			codeLength += exception_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(216);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DED_ACTION_RESPONSE) {
			codeLength += ded_action_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(215);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DED_SET_RESPONSE) {
			codeLength += ded_set_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(213);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DED_GET_RESPONSE) {
			codeLength += ded_get_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(212);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DED_ACTIONREQUEST) {
			codeLength += ded_actionRequest.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(211);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DED_EVENT_NOTIFICATION_REQUEST) {
			codeLength += ded_event_notification_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(210);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DED_SET_REQUEST) {
			codeLength += ded_set_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(209);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DED_GET_REQUEST) {
			codeLength += ded_get_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(208);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_ACTION_RESPONSE) {
			codeLength += glo_action_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(207);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_SET_RESPONSE) {
			codeLength += glo_set_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(205);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_GET_RESPONSE) {
			codeLength += glo_get_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(204);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_ACTION_REQUEST) {
			codeLength += glo_action_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(203);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_EVENT_NOTIFICATION_REQUEST) {
			codeLength += glo_event_notification_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(202);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_SET_REQUEST) {
			codeLength += glo_set_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(201);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_GET_REQUEST) {
			codeLength += glo_get_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(200);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_RESPONSE) {
			codeLength += action_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(199);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.SET_RESPONSE) {
			codeLength += set_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(197);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GET_RESPONSE) {
			codeLength += get_response.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(196);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST) {
			codeLength += action_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(195);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.EVENT_NOTIFICATION_REQUEST) {
			codeLength += event_notification_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(194);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST) {
			codeLength += set_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(193);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GET_REQUEST) {
			codeLength += get_request.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(192);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_WRITERESPONSE) {
			codeLength += glo_writeResponse.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(45);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_READRESPONSE) {
			codeLength += glo_readResponse.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(44);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_INITIATERESPONSE) {
			codeLength += glo_initiateResponse.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(40);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_WRITEREQUEST) {
			codeLength += glo_writeRequest.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(38);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_READREQUEST) {
			codeLength += glo_readRequest.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(37);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GLO_INITIATEREQUEST) {
			codeLength += glo_initiateRequest.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(33);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.INFORMATIONREPORTREQUEST) {
			codeLength += informationReportRequest.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(24);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.UNCONFIRMEDWRITEREQUEST) {
			codeLength += unconfirmedWriteRequest.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(22);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.CONFIRMEDSERVICEERROR) {
			codeLength += confirmedServiceError.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(14);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.WRITERESPONSE) {
			codeLength += writeResponse.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(13);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.READRESPONSE) {
			codeLength += readResponse.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(12);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.INITIATERESPONSE) {
			codeLength += initiateResponse.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(8);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.WRITEREQUEST) {
			codeLength += writeRequest.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(6);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.READREQUEST) {
			codeLength += readRequest.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(5);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.INITIATEREQUEST) {
			codeLength += initiateRequest.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(1);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		// This block should be unreachable
		throw new IOException("Error encoding AxdrChoice: No item in choice was encoded.");
	}

	@Override
	public int decode(InputStream iStream) throws IOException {
		int codeLength = 0;
		AxdrEnum choosen = new AxdrEnum();

		codeLength += choosen.decode(iStream);
		resetChoices();
		this.choice = Choices.valueOf(choosen.getValue());

		if (choice == Choices.INITIATEREQUEST) {
			initiateRequest = new InitiateRequest();
			codeLength += initiateRequest.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.READREQUEST) {
			readRequest = new ReadRequest();
			codeLength += readRequest.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.WRITEREQUEST) {
			writeRequest = new WriteRequest();
			codeLength += writeRequest.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.INITIATERESPONSE) {
			initiateResponse = new InitiateResponse();
			codeLength += initiateResponse.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.READRESPONSE) {
			readResponse = new ReadResponse();
			codeLength += readResponse.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.WRITERESPONSE) {
			writeResponse = new WriteResponse();
			codeLength += writeResponse.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.CONFIRMEDSERVICEERROR) {
			confirmedServiceError = new ConfirmedServiceError();
			codeLength += confirmedServiceError.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.UNCONFIRMEDWRITEREQUEST) {
			unconfirmedWriteRequest = new UnconfirmedWriteRequest();
			codeLength += unconfirmedWriteRequest.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.INFORMATIONREPORTREQUEST) {
			informationReportRequest = new InformationReportRequest();
			codeLength += informationReportRequest.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_INITIATEREQUEST) {
			glo_initiateRequest = new AxdrOctetString();
			codeLength += glo_initiateRequest.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_READREQUEST) {
			glo_readRequest = new AxdrOctetString();
			codeLength += glo_readRequest.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_WRITEREQUEST) {
			glo_writeRequest = new AxdrOctetString();
			codeLength += glo_writeRequest.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_INITIATERESPONSE) {
			glo_initiateResponse = new AxdrOctetString();
			codeLength += glo_initiateResponse.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_READRESPONSE) {
			glo_readResponse = new AxdrOctetString();
			codeLength += glo_readResponse.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_WRITERESPONSE) {
			glo_writeResponse = new AxdrOctetString();
			codeLength += glo_writeResponse.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GET_REQUEST) {
			get_request = new GET_Request();
			codeLength += get_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST) {
			set_request = new SET_Request();
			codeLength += set_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.EVENT_NOTIFICATION_REQUEST) {
			event_notification_request = new EVENT_NOTIFICATION_Request();
			codeLength += event_notification_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST) {
			action_request = new ACTION_Request();
			codeLength += action_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GET_RESPONSE) {
			get_response = new GET_Response();
			codeLength += get_response.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.SET_RESPONSE) {
			set_response = new SET_Response();
			codeLength += set_response.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_RESPONSE) {
			action_response = new ACTION_Response();
			codeLength += action_response.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_GET_REQUEST) {
			glo_get_request = new AxdrOctetString();
			codeLength += glo_get_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_SET_REQUEST) {
			glo_set_request = new AxdrOctetString();
			codeLength += glo_set_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_EVENT_NOTIFICATION_REQUEST) {
			glo_event_notification_request = new AxdrOctetString();
			codeLength += glo_event_notification_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_ACTION_REQUEST) {
			glo_action_request = new AxdrOctetString();
			codeLength += glo_action_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_GET_RESPONSE) {
			glo_get_response = new AxdrOctetString();
			codeLength += glo_get_response.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_SET_RESPONSE) {
			glo_set_response = new AxdrOctetString();
			codeLength += glo_set_response.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GLO_ACTION_RESPONSE) {
			glo_action_response = new AxdrOctetString();
			codeLength += glo_action_response.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DED_GET_REQUEST) {
			ded_get_request = new AxdrOctetString();
			codeLength += ded_get_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DED_SET_REQUEST) {
			ded_set_request = new AxdrOctetString();
			codeLength += ded_set_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DED_EVENT_NOTIFICATION_REQUEST) {
			ded_event_notification_request = new AxdrOctetString();
			codeLength += ded_event_notification_request.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DED_ACTIONREQUEST) {
			ded_actionRequest = new AxdrOctetString();
			codeLength += ded_actionRequest.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DED_GET_RESPONSE) {
			ded_get_response = new AxdrOctetString();
			codeLength += ded_get_response.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DED_SET_RESPONSE) {
			ded_set_response = new AxdrOctetString();
			codeLength += ded_set_response.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DED_ACTION_RESPONSE) {
			ded_action_response = new AxdrOctetString();
			codeLength += ded_action_response.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.EXCEPTION_RESPONSE) {
			exception_response = new EXCEPTION_Response();
			codeLength += exception_response.decode(iStream);
			return codeLength;
		}

		throw new IOException("Error decoding AxdrChoice: Identifier matched to no item.");
	}

	public void encodeAndSave(int encodingSizeGuess) throws IOException {
		BerByteArrayOutputStream axdrOStream = new BerByteArrayOutputStream(encodingSizeGuess);
		encode(axdrOStream);
		code = axdrOStream.getArray();
	}

	public Choices getChoiceIndex() {
		return this.choice;
	}

	public void setinitiateRequest(InitiateRequest newVal) {
		resetChoices();
		choice = Choices.INITIATEREQUEST;
		initiateRequest = newVal;
	}

	public void setreadRequest(ReadRequest newVal) {
		resetChoices();
		choice = Choices.READREQUEST;
		readRequest = newVal;
	}

	public void setwriteRequest(WriteRequest newVal) {
		resetChoices();
		choice = Choices.WRITEREQUEST;
		writeRequest = newVal;
	}

	public void setinitiateResponse(InitiateResponse newVal) {
		resetChoices();
		choice = Choices.INITIATERESPONSE;
		initiateResponse = newVal;
	}

	public void setreadResponse(ReadResponse newVal) {
		resetChoices();
		choice = Choices.READRESPONSE;
		readResponse = newVal;
	}

	public void setwriteResponse(WriteResponse newVal) {
		resetChoices();
		choice = Choices.WRITERESPONSE;
		writeResponse = newVal;
	}

	public void setconfirmedServiceError(ConfirmedServiceError newVal) {
		resetChoices();
		choice = Choices.CONFIRMEDSERVICEERROR;
		confirmedServiceError = newVal;
	}

	public void setunconfirmedWriteRequest(UnconfirmedWriteRequest newVal) {
		resetChoices();
		choice = Choices.UNCONFIRMEDWRITEREQUEST;
		unconfirmedWriteRequest = newVal;
	}

	public void setinformationReportRequest(InformationReportRequest newVal) {
		resetChoices();
		choice = Choices.INFORMATIONREPORTREQUEST;
		informationReportRequest = newVal;
	}

	public void setglo_initiateRequest(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_INITIATEREQUEST;
		glo_initiateRequest = newVal;
	}

	public void setglo_readRequest(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_READREQUEST;
		glo_readRequest = newVal;
	}

	public void setglo_writeRequest(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_WRITEREQUEST;
		glo_writeRequest = newVal;
	}

	public void setglo_initiateResponse(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_INITIATERESPONSE;
		glo_initiateResponse = newVal;
	}

	public void setglo_readResponse(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_READRESPONSE;
		glo_readResponse = newVal;
	}

	public void setglo_writeResponse(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_WRITERESPONSE;
		glo_writeResponse = newVal;
	}

	public void setget_request(GET_Request newVal) {
		resetChoices();
		choice = Choices.GET_REQUEST;
		get_request = newVal;
	}

	public void setset_request(SET_Request newVal) {
		resetChoices();
		choice = Choices.SET_REQUEST;
		set_request = newVal;
	}

	public void setevent_notification_request(EVENT_NOTIFICATION_Request newVal) {
		resetChoices();
		choice = Choices.EVENT_NOTIFICATION_REQUEST;
		event_notification_request = newVal;
	}

	public void setaction_request(ACTION_Request newVal) {
		resetChoices();
		choice = Choices.ACTION_REQUEST;
		action_request = newVal;
	}

	public void setget_response(GET_Response newVal) {
		resetChoices();
		choice = Choices.GET_RESPONSE;
		get_response = newVal;
	}

	public void setset_response(SET_Response newVal) {
		resetChoices();
		choice = Choices.SET_RESPONSE;
		set_response = newVal;
	}

	public void setaction_response(ACTION_Response newVal) {
		resetChoices();
		choice = Choices.ACTION_RESPONSE;
		action_response = newVal;
	}

	public void setglo_get_request(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_GET_REQUEST;
		glo_get_request = newVal;
	}

	public void setglo_set_request(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_SET_REQUEST;
		glo_set_request = newVal;
	}

	public void setglo_event_notification_request(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_EVENT_NOTIFICATION_REQUEST;
		glo_event_notification_request = newVal;
	}

	public void setglo_action_request(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_ACTION_REQUEST;
		glo_action_request = newVal;
	}

	public void setglo_get_response(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_GET_RESPONSE;
		glo_get_response = newVal;
	}

	public void setglo_set_response(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_SET_RESPONSE;
		glo_set_response = newVal;
	}

	public void setglo_action_response(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.GLO_ACTION_RESPONSE;
		glo_action_response = newVal;
	}

	public void setded_get_request(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.DED_GET_REQUEST;
		ded_get_request = newVal;
	}

	public void setded_set_request(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.DED_SET_REQUEST;
		ded_set_request = newVal;
	}

	public void setded_event_notification_request(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.DED_EVENT_NOTIFICATION_REQUEST;
		ded_event_notification_request = newVal;
	}

	public void setded_actionRequest(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.DED_ACTIONREQUEST;
		ded_actionRequest = newVal;
	}

	public void setded_get_response(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.DED_GET_RESPONSE;
		ded_get_response = newVal;
	}

	public void setded_set_response(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.DED_SET_RESPONSE;
		ded_set_response = newVal;
	}

	public void setded_action_response(AxdrOctetString newVal) {
		resetChoices();
		choice = Choices.DED_ACTION_RESPONSE;
		ded_action_response = newVal;
	}

	public void setexception_response(EXCEPTION_Response newVal) {
		resetChoices();
		choice = Choices.EXCEPTION_RESPONSE;
		exception_response = newVal;
	}

	private void resetChoices() {
		choice = Choices._ERR_NONE_SELECTED;
		initiateRequest = null;
		readRequest = null;
		writeRequest = null;
		initiateResponse = null;
		readResponse = null;
		writeResponse = null;
		confirmedServiceError = null;
		unconfirmedWriteRequest = null;
		informationReportRequest = null;
		glo_initiateRequest = null;
		glo_readRequest = null;
		glo_writeRequest = null;
		glo_initiateResponse = null;
		glo_readResponse = null;
		glo_writeResponse = null;
		get_request = null;
		set_request = null;
		event_notification_request = null;
		action_request = null;
		get_response = null;
		set_response = null;
		action_response = null;
		glo_get_request = null;
		glo_set_request = null;
		glo_event_notification_request = null;
		glo_action_request = null;
		glo_get_response = null;
		glo_set_response = null;
		glo_action_response = null;
		ded_get_request = null;
		ded_set_request = null;
		ded_event_notification_request = null;
		ded_actionRequest = null;
		ded_get_response = null;
		ded_set_response = null;
		ded_action_response = null;
		exception_response = null;
	}

	@Override
	public String toString() {
		if (choice == Choices.INITIATEREQUEST) {
			return "choice: {initiateRequest: " + initiateRequest + "}";
		}

		if (choice == Choices.READREQUEST) {
			return "choice: {readRequest: " + readRequest + "}";
		}

		if (choice == Choices.WRITEREQUEST) {
			return "choice: {writeRequest: " + writeRequest + "}";
		}

		if (choice == Choices.INITIATERESPONSE) {
			return "choice: {initiateResponse: " + initiateResponse + "}";
		}

		if (choice == Choices.READRESPONSE) {
			return "choice: {readResponse: " + readResponse + "}";
		}

		if (choice == Choices.WRITERESPONSE) {
			return "choice: {writeResponse: " + writeResponse + "}";
		}

		if (choice == Choices.CONFIRMEDSERVICEERROR) {
			return "choice: {confirmedServiceError: " + confirmedServiceError + "}";
		}

		if (choice == Choices.UNCONFIRMEDWRITEREQUEST) {
			return "choice: {unconfirmedWriteRequest: " + unconfirmedWriteRequest + "}";
		}

		if (choice == Choices.INFORMATIONREPORTREQUEST) {
			return "choice: {informationReportRequest: " + informationReportRequest + "}";
		}

		if (choice == Choices.GLO_INITIATEREQUEST) {
			return "choice: {glo_initiateRequest: " + glo_initiateRequest + "}";
		}

		if (choice == Choices.GLO_READREQUEST) {
			return "choice: {glo_readRequest: " + glo_readRequest + "}";
		}

		if (choice == Choices.GLO_WRITEREQUEST) {
			return "choice: {glo_writeRequest: " + glo_writeRequest + "}";
		}

		if (choice == Choices.GLO_INITIATERESPONSE) {
			return "choice: {glo_initiateResponse: " + glo_initiateResponse + "}";
		}

		if (choice == Choices.GLO_READRESPONSE) {
			return "choice: {glo_readResponse: " + glo_readResponse + "}";
		}

		if (choice == Choices.GLO_WRITERESPONSE) {
			return "choice: {glo_writeResponse: " + glo_writeResponse + "}";
		}

		if (choice == Choices.GET_REQUEST) {
			return "choice: {get_request: " + get_request + "}";
		}

		if (choice == Choices.SET_REQUEST) {
			return "choice: {set_request: " + set_request + "}";
		}

		if (choice == Choices.EVENT_NOTIFICATION_REQUEST) {
			return "choice: {event_notification_request: " + event_notification_request + "}";
		}

		if (choice == Choices.ACTION_REQUEST) {
			return "choice: {action_request: " + action_request + "}";
		}

		if (choice == Choices.GET_RESPONSE) {
			return "choice: {get_response: " + get_response + "}";
		}

		if (choice == Choices.SET_RESPONSE) {
			return "choice: {set_response: " + set_response + "}";
		}

		if (choice == Choices.ACTION_RESPONSE) {
			return "choice: {action_response: " + action_response + "}";
		}

		if (choice == Choices.GLO_GET_REQUEST) {
			return "choice: {glo_get_request: " + glo_get_request + "}";
		}

		if (choice == Choices.GLO_SET_REQUEST) {
			return "choice: {glo_set_request: " + glo_set_request + "}";
		}

		if (choice == Choices.GLO_EVENT_NOTIFICATION_REQUEST) {
			return "choice: {glo_event_notification_request: " + glo_event_notification_request + "}";
		}

		if (choice == Choices.GLO_ACTION_REQUEST) {
			return "choice: {glo_action_request: " + glo_action_request + "}";
		}

		if (choice == Choices.GLO_GET_RESPONSE) {
			return "choice: {glo_get_response: " + glo_get_response + "}";
		}

		if (choice == Choices.GLO_SET_RESPONSE) {
			return "choice: {glo_set_response: " + glo_set_response + "}";
		}

		if (choice == Choices.GLO_ACTION_RESPONSE) {
			return "choice: {glo_action_response: " + glo_action_response + "}";
		}

		if (choice == Choices.DED_GET_REQUEST) {
			return "choice: {ded_get_request: " + ded_get_request + "}";
		}

		if (choice == Choices.DED_SET_REQUEST) {
			return "choice: {ded_set_request: " + ded_set_request + "}";
		}

		if (choice == Choices.DED_EVENT_NOTIFICATION_REQUEST) {
			return "choice: {ded_event_notification_request: " + ded_event_notification_request + "}";
		}

		if (choice == Choices.DED_ACTIONREQUEST) {
			return "choice: {ded_actionRequest: " + ded_actionRequest + "}";
		}

		if (choice == Choices.DED_GET_RESPONSE) {
			return "choice: {ded_get_response: " + ded_get_response + "}";
		}

		if (choice == Choices.DED_SET_RESPONSE) {
			return "choice: {ded_set_response: " + ded_set_response + "}";
		}

		if (choice == Choices.DED_ACTION_RESPONSE) {
			return "choice: {ded_action_response: " + ded_action_response + "}";
		}

		if (choice == Choices.EXCEPTION_RESPONSE) {
			return "choice: {exception_response: " + exception_response + "}";
		}

		return "unknown";
	}

}
