package org.openmuc.jdlms;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class SecurityUtilsTest {

	private final static String KEK_STRING = "000102030405060708090a0b0c0d0e0f";
	private final static String KEY_STRING = "00112233445566778899aabbccddeeff";
	private final static String WRAPPED_KEY_EXPECTED_STRING = "1fa68b0a8112b447aef34bd8fb5a7b829d3e862371d2cfe5";

	private byte[] key;
	private byte[] kek;
	private byte[] wrappedKeyTest;

	@Before
	public void setUp() {
		key = HexConverter.fromShortHexString(KEY_STRING);
		kek = HexConverter.fromShortHexString(KEK_STRING);
		wrappedKeyTest = HexConverter.fromShortHexString(WRAPPED_KEY_EXPECTED_STRING);
	}

	@Test
	public void aesRFC3394KeyWrapTest() {
		byte[] warppedKey = SecurityUtils.aesRFC3394KeyWrap(kek, key);
		Assert.assertArrayEquals(wrappedKeyTest, warppedKey);
	}

	// @Test
	// public void aesRFC3394KeyUnwrapTest() {
	// byte[] unwrappedKey = new byte[] {};
	// try {
	// unwrappedKey = Security.aesRFC3394KeyUnwrap(kek, wrappedKeyTest);
	// } catch (InvalidCipherTextException e) {
	// Assert.assertFalse(e.getMessage(), true);
	// }
	// Assert.assertArrayEquals(key, unwrappedKey);
	// }

}
